package ch.unige.solidify.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.repository.NoRepositoryBean;
import org.springframework.data.repository.PagingAndSortingRepository;

@NoRepositoryBean
public interface SolidifyRepository<T> extends PagingAndSortingRepository<T, String>, JpaSpecificationExecutor<T> {

  default <V> Page<V> findByParentId(String parentId, Class<?> parentClass, Class<V> childClass, Pageable pageable) {

    throw new UnsupportedOperationException("Missing implementation 'findByParentId' method (" + parentClass.getSimpleName() + " -> " +
            childClass.getSimpleName() + ")");
  }

  default <V> V findByParentIdAndChildId(String parentId, Class<?> parentClass, Class<V> childClass, String id) {

    throw new UnsupportedOperationException("Missing implementation 'findByParentIdAndChildId' method (" + parentClass.getSimpleName() + " -> " +
            childClass.getSimpleName() + ")");
  }

}
