package ch.unige.solidify.rest;

import java.io.Serializable;

public class FacetRequest implements Serializable {

  /**
   * Facet name in search results
   */
  private String name;

  /**
   * Minimum number of occurrences to be returned as facet value
   */
  private Integer minCount;

  /**
   * Maximum number of facet values to return
   */
  private Integer limit;

  /**
   * Name of the facet index field
   */
  private String field;

  public FacetRequest() {
  }

  public FacetRequest(String name, Integer minCount, Integer limit, String field) {
    this.name = name;
    this.minCount = minCount;
    this.limit = limit;
    this.field = field;
  }

  public String getName() {
    return this.name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Integer getMinCount() {
    return this.minCount;
  }

  public void setMinCount(Integer minCount) {
    this.minCount = minCount;
  }

  public Integer getLimit() {
    return this.limit;
  }

  public void setLimit(Integer limit) {
    this.limit = limit;
  }

  public String getField() {
    return this.field;
  }

  public void setField(String field) {
    this.field = field;
  }
}
