package ch.unige.solidify.util;

import org.springframework.security.authentication.AnonymousAuthenticationToken;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;

import ch.unige.solidify.model.User;

public class UserTool {

  /**
   * Get User principal
   *
   * @return USer
   */
  public static User getUserPrincipal() {
    final Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
    if (authentication != null && !(authentication instanceof AnonymousAuthenticationToken)) {
      final Object principal = authentication.getPrincipal();
      if (principal instanceof User) {
        return (User) principal;
      }
    }
    return null;
  }

}
